#include "7z.h"
#include "PipedInOutStreams.h"

#include "LZMAEncoder.h"
#include "LZMADecoder.h"

bool compress_lzma_7z(unsigned algo, unsigned dictionary_size, unsigned num_fast_bytes) throw () {
	try {
		NCompress::NLZMA::CEncoder cc;
		
		if (cc.SetDictionarySize(dictionary_size) != S_OK)
			return false;

		if (cc.SetEncoderNumFastBytes(num_fast_bytes) != S_OK)
			return false;

		if (cc.SetEncoderAlgorithm(algo) != S_OK)
			return false;

		ISequentialInStream* in = new PipedInStream();
		ISequentialOutStream* out = new PipedOutStream();
		
		if (cc.WriteCoderProperties(out) != S_OK)
			return false;

		if (cc.Code(in, out) != S_OK)
			return false;

		return true;
	} catch (...) {
		return false;
	}
}

bool decompress_lzma_7z() throw () {
	try {
		NCompress::NLZMA::CDecoder cc;

		ISequentialInStream* in = new PipedInStream();
		ISequentialOutStream* out = new PipedOutStream();

		if (cc.ReadCoderProperties(in) != S_OK)
			return false;

		if (cc.Code(in, out) != S_OK)
			return false;

		return true;
	} catch (...) {
		return false;
	}
}
